ASSEMBLE
        NIBASC        /HPHP48-R/
        LIST
        LISTM
RPL

::
    
CODE

* Include unsupported entry point equates

    INCLUDE unsuppentries.h

* Check and see if we have enough memory to push an extended real and a 16-digit hex string to the stack
* If not, generate an error exit.

    GOSUB   check_mem       

    GOSBVL  =SAVPTR
    
********************************************************************************
** !!CAVEAT EMPTOR!!
**
** The following code disables interrupts so that the timer service routines 
** in the interrupt system don't screw up the 60 second countdown. Since this
** does not install an interrupt handler, if the calculator experiences a VLBI
** condition while this code is executing, you may get a TTRM. So, make sure
** that your batteries are fresh :)
**
********************************************************************************
    
    GOSBVL  =DisableIntr    * Abandon all hope ye who enter here...
    
    GOSUB   saveTimeandInit * Save system time and do some initialization
    
-   GOSUB   RCL_R1          * "Recall" R1 into working regs

    CDEX    W               * Save "R1" into A.W and B.W
    B=C     W               *
    CDEX    W               *
    A=C     W               *
    
    GOSUB   RCL_R0          * "Recall" R0 into working regs
    
    GOSBVL  DOMULTF!        * 15-digit extended real floating point BCD multiply
    
    GOSUB   RCL_R1          * "Recall" R1 into working regs
    
    P=      9               * Set extended real sign nibble to "9" so that we are
    C=P     15              * performing a subtraction
    
    GOSBVL  =RADDF          * Perform subtraction
    
    GOSUB   RCL_R0          * "Recall" R0 into working regs
    
    GOSBVL  DODIVF!         * 15-digit extended real floating point BCD division
    
    GOSUB   RCL_R1          * "Recall" R1 into working regs
    
    GOSBVL  DOMULTF!        * 15-digit extended real floating point BCD multiply
    
    C=0     W               * Load 3.5 in BCD into C.W and D.W
    D=0     W               *
    P=      13              *
    LC(5)   #35             *
    CDEX    W               *
    
    GOSBVL  DODIVF!         * 15-digit extended real floating point BCD division
    
    GOSBVL  SQRTF           * 15-digit extended real floating point BCD square root
    
    SETHEX                  * Put us back into HEX mode

    C=R4                    * "Recall" "R2" and increment it and then save it
    C=C+1   W               *
    R4=C                    *

    D1=(5)  =TIMER2         * Read TIMER2 and see if it has underflowed. If so then
    P=  7                   * exit the loop.
    C=DAT1  WP              *
    C=C+C   P               *
    GOC end                 *

    SETDEC                  * 
    GOTO    -               * Loop

    
end 

* Restore TIMER2 to what it should be, taking into account its current value
* and the time taken to execute the 60 second countdown

    GOSUB    restoreSysTime 

** Push the extended real result to the stack

    P=      0
    GOSBVL  PUSH%%          
    GOSBVL  =SAVPTR
** Re-enable interrupts
    GOSBVL  =AllowIntr

** Push value of "R2" as a hex string to the stack

    A=R4    
    P=      15
    GOVLNG  =PUSHhxsLoop    * We're done

* The following subroutine "recalls" the extended real value 1.01234 EEX 6 into
* C.W and D.W
RCL_R0
    C=0     W
    D=0     W
    P=      0
    LC(1)   #6
    CDEX    W
    P=      8
    LC(7)   #1012340
    CDEX    W
    RTN

* The following subroutine "recalls" the extended real value 2.345 into C.W and D.W
*   
RCL_R1
    C=0     W
    D=0     W
    P=      11
    LC(4)   #2345
    CDEX    W
    RTN
 
    INCLUDE common.a     * Include common assembly subroutine code
    
ENDCODE

     INCLUDE    common.s ( Include common Sys-RPL code )
;
